<template>
  <div>
    <v-card>
      <v-card-title class="light"
        >{{ modalHeader }} një Arkë / Bankë</v-card-title
      >
      <v-container>
        <v-row class="mx-2">
          <v-col class="justify-center justify-space-between" cols="12">
            <v-checkbox v-model="request.is_bank" label="Eshte Bank" />
          </v-col>
          <v-col class="align-center justify-space-between" cols="6">
            <v-text-field label="Emri*" v-model="request.unit_name" />
          </v-col>
          <v-col cols="6">
            <v-text-field label="Kodi*" v-model="request.unit_code" />
          </v-col>
          <v-col cols="6">
            <v-text-field label="Pershkrimi" v-model="request.description" />
          </v-col>
          <v-col cols="6">
            <currency-select
              v-model="request.currency_id"
              @currency_id="getCurrencyId"
            />
          </v-col>
        </v-row>
      </v-container>
      <v-card-actions>
        <v-spacer />
        <v-btn text color="gray" @click="closeModal">Anullo</v-btn>
        <f-submit-btn
          @click="modalType === 'create' ? create() : update()"
          :loading="loading"
          :disabled="loading"
        />
      </v-card-actions>
    </v-card>
  </div>
</template>

<script lang="ts">
import api from '@/plugins/api'
import { Vue, Component, Prop, Watch } from 'vue-property-decorator'
import FSubmitBtn from '@/components/buttons/FSubmitBtn.vue'
import CurrencySelect from '@/components/general/CurrencySelect.vue'

@Component({
  components: { FSubmitBtn, CurrencySelect },
})
export default class CreateBank extends Vue {
  @Prop(String) modalType!: string
  @Prop(Object) data!: any

  @Watch('data')
  onDataChange(newValue) {
    this.request = newValue
  }

  request: any = {
    unit_name: null,
    unit_code: null,
    description: null,
    is_bank: true,
    start_exchange_rate: 0,
  }
  loading = false

  closeModal() {
    this.$emit('close', 'edit_banks')
    if (this.modalType === 'create') {
      this.request.unit_name = ''
      this.request.unit_code = ''
      this.request.description = ''
      this.request.is_bank = false
      this.request.start_exchange_rate = 0
    }
  }

  create() {
    this.loading = true
    api()
      .post(`/api/account-management/banks`, this.request)
      .then(response => {
        if (response.data.status === 2) {
          return alert(response.data.message)
        } else {
          alert('Banka u shtua me sukses')
          this.closeModal()
          this.$emit('reload-banks')
        }
      })
      .catch(error => {
        alert(error.message)
      })
      .finally(() => {
        this.loading = false
      })
  }

  update() {
    this.loading = true
    api()
      .put(`/api/account-management/banks/${this.request.id}`, this.request)
      .then(response => {
        if (response.data.status === 2) {
          return alert(response.data.message)
        } else {
          alert('Banka u modifikua me sukses')
          this.closeModal()
          this.$emit('reload-banks')
        }
      })
      .catch(error => {
        alert(error.message)
      })
      .finally(() => {
        this.loading = false
      })
  }

  get modalHeader() {
    return this.modalType === 'create' ? 'Shto' : 'Modifiko'
  }
  getCurrencyId(id) {
    this.request.currency_id = id
  }

  mounted() {
    if (this.data) {
      this.request = this.data
    }
  }
}
</script>
